#include <stdlib.h>
#include <stdio.h>
#include <sys/shm.h>
#include <unistd.h>
#include "shared.h"

void Consumer(SharedStruct* sharedMem);
void consume_item(int item, SharedStruct* sharedMem);
int remove_item(SharedStruct* sharedMem);

int main(int argc, char* argv[])
{
    if (argc != 2)
    {
        fprintf(stderr, "Usage: %s SharedID# \n", argv[0]);
        exit(1);
    }
    int sharedID = StringToNumber(argv[1]);
    SharedStruct* sharedMem = shmat(sharedID, NULL, 0);
    Consumer(sharedMem);
    //  TODO: Fix buffer not printing correctly
    return 0;
}

//  Consumer main function
//  TODO:   Add waiting for one consumer at a time
//          Add ability to use shared memory
void Consumer(SharedStruct* sharedMem)
{
    int consumeNum;
    while (1)
    {
        sem_wait(&sharedMem->semConsumer);
        // down(&full);
        // down(&mutex);
        consumeNum = remove_item(sharedMem);
        printf("%d was consumed.\n", consumeNum);
        // up(&mutex);
        // up(&empty);
        consume_item(consumeNum, sharedMem);
        sem_post(&sharedMem->semProducer);
        break;
    }
}

//  Manage item taken from shared memory
void consume_item(int item, SharedStruct* sharedMem)
{
    sharedMem->count[item]++;
    return;
}

//  Take item out of shared memory
int remove_item(SharedStruct* sharedMem)
{
    int item = sharedMem->buffer[0];
    sharedMem->buffer[0] = -1;
    return item;
}